/* English Clock v2.4 Header file for screen mode find out bit */
/* (C) 1995 by Ben Matthew */

#include <graphics/view.h>
#include <graphics/gfx.h>
#include <graphics/gfxbase.h>

struct {
   int s_width;       /* Width of current screen */
   int s_height;      /* Height of current screen */
   int s_bar;         /* Bar height of windows.  Other font */
   int s_cols;        /* Number of colours available */
   int s_mode;        /* Mode according to s_cols */
}screentype;

short getscreentype(void);

short getscreentype(void) {

   screentype.s_width=pubscreen->Width;
   screentype.s_height=pubscreen->Height;
   screentype.s_bar=pubscreen->BarHeight;
   screentype.s_cols=pubscreen->ViewPort.ColorMap->PalExtra->pe_SharableColors;

   /* Following code works out the colour mode: */

   switch(screentype.s_cols) {
      case 1:     screentype.s_mode=0;    break;
      case 3:     screentype.s_mode=1;    break;
      case 7:     screentype.s_mode=2;    break;
      case 15:    screentype.s_mode=3;    break;
      case 31:    screentype.s_mode=4;    break;
      case 63:    screentype.s_mode=5;    break;
      case 127:   screentype.s_mode=6;    break;
      case 255:   screentype.s_mode=7;    break;
      default:    screentype.s_mode=0;    break;
   }
   return(0);

}


